// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cam_ts_msgs:msg/CurvatureCalculationMode.idl
// generated code does not contain a copyright notice

#include "etsi_its_cam_ts_msgs/msg/detail/curvature_calculation_mode__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
const rosidl_type_hash_t *
etsi_its_cam_ts_msgs__msg__CurvatureCalculationMode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x40, 0x65, 0x8a, 0x57, 0x7b, 0x18, 0xc4, 0x72,
      0x63, 0xb3, 0xf2, 0x1e, 0xa6, 0xc3, 0x2d, 0xf9,
      0xe2, 0x4d, 0x90, 0xa8, 0xb6, 0xc5, 0xbf, 0xa7,
      0x98, 0x5a, 0x3b, 0xe9, 0x3a, 0x77, 0x35, 0x75,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cam_ts_msgs__msg__CurvatureCalculationMode__TYPE_NAME[] = "etsi_its_cam_ts_msgs/msg/CurvatureCalculationMode";

// Define type names, field names, and default values
static char etsi_its_cam_ts_msgs__msg__CurvatureCalculationMode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cam_ts_msgs__msg__CurvatureCalculationMode__FIELDS[] = {
  {
    {etsi_its_cam_ts_msgs__msg__CurvatureCalculationMode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cam_ts_msgs__msg__CurvatureCalculationMode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cam_ts_msgs__msg__CurvatureCalculationMode__TYPE_NAME, 49, 49},
      {etsi_its_cam_ts_msgs__msg__CurvatureCalculationMode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn\n"
  "#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   cam_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * The DE describes whether the yaw rate is used to calculate the curvature for a curvature value.\n"
  "#  * \n"
  "#  * The value shall be set to:\n"
  "#  * - 0 - `yawRateUsed`    - if the yaw rate is used,\n"
  "#  * - 1 - `yawRateNotUsed` - if the yaw rate is not used,\n"
  "#  * - 2 - `unavailable`    - if the information of curvature calculation mode is unknown.\n"
  "#  *\n"
  "#  * @category: Vehicle information\n"
  "#  * @revision: V1.3.1\n"
  "#  */\n"
  "# CurvatureCalculationMode ::= ENUMERATED {\n"
  "#     yawRateUsed    (0), \n"
  "#     yawRateNotUsed (1), \n"
  "#     unavailable    (2), \n"
  "#     ...\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 YAW_RATE_USED = 0\n"
  "uint8 YAW_RATE_NOT_USED = 1\n"
  "uint8 UNAVAILABLE = 2\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cam_ts_msgs__msg__CurvatureCalculationMode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cam_ts_msgs__msg__CurvatureCalculationMode__TYPE_NAME, 49, 49},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2526, 2526},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cam_ts_msgs__msg__CurvatureCalculationMode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cam_ts_msgs__msg__CurvatureCalculationMode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
