// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cam_ts_msgs:msg/TrafficRule.idl
// generated code does not contain a copyright notice

#include "etsi_its_cam_ts_msgs/msg/detail/traffic_rule__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
const rosidl_type_hash_t *
etsi_its_cam_ts_msgs__msg__TrafficRule__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xe3, 0x9e, 0x38, 0x0c, 0xa0, 0xda, 0xd4, 0x04,
      0x66, 0x70, 0x16, 0xf2, 0xeb, 0x23, 0xf1, 0x1e,
      0x32, 0x8b, 0x74, 0xf6, 0x5b, 0x90, 0x95, 0x9c,
      0x31, 0xc1, 0x77, 0x13, 0xa0, 0xc7, 0x6b, 0xa5,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cam_ts_msgs__msg__TrafficRule__TYPE_NAME[] = "etsi_its_cam_ts_msgs/msg/TrafficRule";

// Define type names, field names, and default values
static char etsi_its_cam_ts_msgs__msg__TrafficRule__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cam_ts_msgs__msg__TrafficRule__FIELDS[] = {
  {
    {etsi_its_cam_ts_msgs__msg__TrafficRule__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cam_ts_msgs__msg__TrafficRule__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cam_ts_msgs__msg__TrafficRule__TYPE_NAME, 36, 36},
      {etsi_its_cam_ts_msgs__msg__TrafficRule__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn\n"
  "#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   cam_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE indicates traffic rules that apply to vehicles at a certain position.\n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - `0` - if overtaking is prohibited for all vehicles,\n"
  "#  * - `1` - if overtaking is prohibited for trucks,\n"
  "#  * - `2` - if vehicles should pass to the right lane,\n"
  "#  * - `3` - if vehicles should pass to the left lane.\n"
  "#  * - `4` - if vehicles should pass to the left or right lane.\n"
  "#  *\n"
  "#  * @category: Infrastructure information, Traffic information\n"
  "#  * @revision: Editorial update in V2.1.1\n"
  "#  */\n"
  "# TrafficRule ::= ENUMERATED {\n"
  "#     noPassing          (0), \n"
  "#     noPassingForTrucks (1), \n"
  "#     passToRight        (2), \n"
  "#     passToLeft         (3), \n"
  "#     ...,\n"
  "#     passToLeftOrRight   (4)\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 NO_PASSING = 0\n"
  "uint8 NO_PASSING_FOR_TRUCKS = 1\n"
  "uint8 PASS_TO_RIGHT = 2\n"
  "uint8 PASS_TO_LEFT = 3\n"
  "uint8 PASS_TO_LEFT_OR_RIGHT = 4\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cam_ts_msgs__msg__TrafficRule__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cam_ts_msgs__msg__TrafficRule__TYPE_NAME, 36, 36},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2756, 2756},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cam_ts_msgs__msg__TrafficRule__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cam_ts_msgs__msg__TrafficRule__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
