// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cam_ts_msgs:msg/AccelerationControl.idl
// generated code does not contain a copyright notice

#include "etsi_its_cam_ts_msgs/msg/detail/acceleration_control__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
const rosidl_type_hash_t *
etsi_its_cam_ts_msgs__msg__AccelerationControl__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x33, 0x96, 0x9d, 0x8c, 0x86, 0xb7, 0xb5, 0x75,
      0xa5, 0x6a, 0xd9, 0x0a, 0xf9, 0xc4, 0x73, 0xe1,
      0xf8, 0x88, 0xc5, 0x4d, 0x38, 0xd5, 0x8b, 0xc2,
      0x48, 0x7e, 0xc5, 0xb0, 0xef, 0x53, 0x24, 0x73,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cam_ts_msgs__msg__AccelerationControl__TYPE_NAME[] = "etsi_its_cam_ts_msgs/msg/AccelerationControl";

// Define type names, field names, and default values
static char etsi_its_cam_ts_msgs__msg__AccelerationControl__FIELD_NAME__value[] = "value";
static char etsi_its_cam_ts_msgs__msg__AccelerationControl__FIELD_NAME__bits_unused[] = "bits_unused";

static rosidl_runtime_c__type_description__Field etsi_its_cam_ts_msgs__msg__AccelerationControl__FIELDS[] = {
  {
    {etsi_its_cam_ts_msgs__msg__AccelerationControl__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {etsi_its_cam_ts_msgs__msg__AccelerationControl__FIELD_NAME__bits_unused, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cam_ts_msgs__msg__AccelerationControl__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cam_ts_msgs__msg__AccelerationControl__TYPE_NAME, 44, 44},
      {etsi_its_cam_ts_msgs__msg__AccelerationControl__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn\n"
  "#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   cam_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE indicates the current controlling mechanism for longitudinal movement of the vehicle.\n"
  "#  * The data may be provided via the in-vehicle network. It indicates whether a specific in-vehicle\n"
  "#  * acceleration control system is engaged or not. Currently, this DE includes the information of the\n"
  "#  * vehicle brake pedal, gas pedal, emergency brake system, collision warning system, adaptive cruise\n"
  "#  * control system, cruise control system and speed limiter system.\n"
  "#  *\n"
  "#  * The corresponding bit shall be set to 1 under the following conditions:\n"
  "#  * - 0 - `brakePedalEngaged`      - Driver is stepping on the brake pedal,\n"
  "#  * - 1 - `gasPedalEngaged`        - Driver is stepping on the gas pedal,\n"
  "#  * - 2 - `emergencyBrakeEngaged`  - emergency brake system is engaged,\n"
  "#  * - 3 - `collisionWarningEngaged`- collision warning system is engaged,\n"
  "#  * - 4 - `accEngaged`             - ACC is engaged,\n"
  "#  * - 5 - `cruiseControlEngaged`   - cruise control is engaged,\n"
  "#  * - 6 - `speedLimiterEngaged`    - speed limiter is engaged.\n"
  "#  *\n"
  "#  * Otherwise (for example when the corresponding system is not available due to non equipped system\n"
  "#  * or information is unavailable), the corresponding bit shall be set to 0.\n"
  "#  *\n"
  "#  * @note: The system engagement condition is OEM specific and therefore out of scope of the present document.\n"
  "#  * @category: Vehicle information\n"
  "#  * @revision: V1.3.1\n"
  "#  */\n"
  "# AccelerationControl ::= BIT STRING {\n"
  "#     brakePedalEngaged       (0),\n"
  "#     gasPedalEngaged         (1),\n"
  "#     emergencyBrakeEngaged   (2),\n"
  "#     collisionWarningEngaged (3),\n"
  "#     accEngaged              (4),\n"
  "#     cruiseControlEngaged    (5),\n"
  "#     speedLimiterEngaged     (6)\n"
  "# } (SIZE(7))\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8[] value\n"
  "uint8 bits_unused\n"
  "uint8 SIZE_BITS = 7\n"
  "uint8 BIT_INDEX_BRAKE_PEDAL_ENGAGED = 0\n"
  "uint8 BIT_INDEX_GAS_PEDAL_ENGAGED = 1\n"
  "uint8 BIT_INDEX_EMERGENCY_BRAKE_ENGAGED = 2\n"
  "uint8 BIT_INDEX_COLLISION_WARNING_ENGAGED = 3\n"
  "uint8 BIT_INDEX_ACC_ENGAGED = 4\n"
  "uint8 BIT_INDEX_CRUISE_CONTROL_ENGAGED = 5\n"
  "uint8 BIT_INDEX_SPEED_LIMITER_ENGAGED = 6\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cam_ts_msgs__msg__AccelerationControl__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cam_ts_msgs__msg__AccelerationControl__TYPE_NAME, 44, 44},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3928, 3928},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cam_ts_msgs__msg__AccelerationControl__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cam_ts_msgs__msg__AccelerationControl__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
