// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cam_ts_msgs:msg/PerformanceClass.idl
// generated code does not contain a copyright notice

#include "etsi_its_cam_ts_msgs/msg/detail/performance_class__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
const rosidl_type_hash_t *
etsi_its_cam_ts_msgs__msg__PerformanceClass__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x9c, 0x13, 0xd9, 0x9a, 0x14, 0x72, 0xfb, 0x54,
      0x14, 0xb3, 0xdc, 0xc2, 0x96, 0x1c, 0xa4, 0x07,
      0x8c, 0xf6, 0xdf, 0xb7, 0x7b, 0xf9, 0xe6, 0x19,
      0x5d, 0x53, 0x09, 0xc3, 0x97, 0x46, 0x6a, 0x9e,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cam_ts_msgs__msg__PerformanceClass__TYPE_NAME[] = "etsi_its_cam_ts_msgs/msg/PerformanceClass";

// Define type names, field names, and default values
static char etsi_its_cam_ts_msgs__msg__PerformanceClass__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cam_ts_msgs__msg__PerformanceClass__FIELDS[] = {
  {
    {etsi_its_cam_ts_msgs__msg__PerformanceClass__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cam_ts_msgs__msg__PerformanceClass__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cam_ts_msgs__msg__PerformanceClass__TYPE_NAME, 41, 41},
      {etsi_its_cam_ts_msgs__msg__PerformanceClass__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn\n"
  "#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   cam_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE denotes the ability of an ITS-S to provide up-to-date information.\n"
  "#  * A performance class value is used to describe age of data. The exact values are out of scope of the present document.\n"
  "#  * \n"
  "#  *  The value shall be set to:\n"
  "#  * - `0` if  the performance class is unknown,\n"
  "#  * - `1` for performance class A as defined in ETSI TS 101 539-1 [5],\n"
  "#  * - `2` for performance class B as defined in ETSI TS 101 539-1 [5],\n"
  "#  * -  3-7 reserved for future use.\n"
  "#  *\n"
  "#  * @category: Vehicle information\n"
  "#  * @revision: Editorial update in V2.1.1\n"
  "#  */\n"
  "# PerformanceClass ::= INTEGER {\n"
  "#     unavailable       (0), \n"
  "#     performanceClassA (1), \n"
  "#     performanceClassB (2)\n"
  "# } (0..7)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 7\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 PERFORMANCE_CLASS_A = 1\n"
  "uint8 PERFORMANCE_CLASS_B = 2\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cam_ts_msgs__msg__PerformanceClass__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cam_ts_msgs__msg__PerformanceClass__TYPE_NAME, 41, 41},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2703, 2703},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cam_ts_msgs__msg__PerformanceClass__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cam_ts_msgs__msg__PerformanceClass__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
