// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cam_ts_msgs:msg/SteeringWheelAngleValue.idl
// generated code does not contain a copyright notice

#include "etsi_its_cam_ts_msgs/msg/detail/steering_wheel_angle_value__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
const rosidl_type_hash_t *
etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x35, 0x7d, 0x78, 0x3a, 0x63, 0x6c, 0x48, 0x5e,
      0x9b, 0xc2, 0x0e, 0x71, 0xf9, 0xd2, 0xce, 0xb1,
      0x4c, 0x86, 0xcb, 0x4f, 0x4f, 0x8c, 0xb5, 0x60,
      0x14, 0x52, 0xdb, 0x2e, 0xde, 0xe5, 0x51, 0x66,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__TYPE_NAME[] = "etsi_its_cam_ts_msgs/msg/SteeringWheelAngleValue";

// Define type names, field names, and default values
static char etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__FIELDS[] = {
  {
    {etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__TYPE_NAME, 48, 48},
      {etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn\n"
  "#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   cam_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the steering wheel angle of the vehicle at certain point in time.\n"
  "#  * The value shall be provided in the vehicle coordinate system as defined in ISO 8855 [21], clause 2.11.\n"
  "#  * \n"
  "#  * The value shall be set to:\n"
  "#  * - `-511` if the steering wheel angle is equal to or greater than 511 x 1,5 degrees = 766,5 degrees to the right,\n"
  "#  * - `n` (`n > -511` and `n <= 0`) if  the steering wheel angle is equal to or less than n x 1,5 degrees, and greater than (n-1) x 1,5 degrees, \n"
  "#       turning clockwise (i.e. to the right),\n"
  "#  * - `n` (`n >= 1` and `n < 511`) if the steering wheel angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees, \n"
  "#       turning counter-clockwise (i.e. to the left),\n"
  "#  * - `511` if the steering wheel angle is greater than 510 x 1,5 degrees = 765 degrees to the left,\n"
  "#  * - `512` if information is not available.\n"
  "#  *\n"
  "#  * @unit: 1,5 degree\n"
  "#  * @revision: Description revised in V2.1.1 (meaning of value 511 has changed slightly).\n"
  "#  */\n"
  "# SteeringWheelAngleValue ::= INTEGER { \n"
  "#     negativeOutOfRange (-511),\n"
  "#     positiveOutOfRange (511),\n"
  "#     unavailable        (512)\n"
  "# } (-511..512)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "int16 value\n"
  "int16 MIN = -511\n"
  "int16 MAX = 512\n"
  "int16 NEGATIVE_OUT_OF_RANGE = -511\n"
  "int16 POSITIVE_OUT_OF_RANGE = 511\n"
  "int16 UNAVAILABLE = 512\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__TYPE_NAME, 48, 48},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3198, 3198},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
